<?php
/**
 * DokuWiki Plugin turtlifier (Action Component)
 *
 * @license GPL 2 http://www.gnu.org/licenses/gpl-2.0.html
 * @author  Piotr Mitana <the.mail.of.mi2@gmail.com>
 */

// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();

class action_plugin_turtlifier_turtlifier extends DokuWiki_Action_Plugin
{
	private $page = false;
	private $previousRev = false;
	private $currentRev = false;
	private $username = false;
	private $links = false;
	private $comment = false;
	
	private $operation = false;
	
	public function turtlifyCreation($strona, $nowaRev, $login, $komentarz, $linki)
	{
		$autor = ($login != "") ? "lokiuser:$login" : "lokiguest";
		
		return "lokipage:{$strona}_{$nowaRev} prov:specializationOf lokipage:{$strona} ;\n" .
			"\tprov:wasGeneratedBy lokievent:created_{$strona}_{$nowaRev} .\n" .
			"lokievent:created_{$strona}_{$nowaRev} prov:wasAssociatedWith {$autor} ;\n" .
			"\tlokirel:comment \"{$komentarz}\"" . 
			((count($linki) > 0) ?
				(" ;\n\tprov:used " . implode(" ,\n\t\t", $linki) . " .\n\n") :
				(" .\n\n"));
	}
	
	public function turtlifyEdition($strona, $nowaRev, $staraRev, $login, $komentarz, $linki)
	{
		$linki = array_merge(array("lokipage:{$strona}_{$staraRev}"), $linki);  // Wykorzystuje poprzednią rewizję
		$autor = ($login != "") ? "lokiuser:$login" : "lokiguest";
		
		return "lokipage:{$strona}_{$nowaRev} prov:specializationOf lokipage:{$strona} ;\n" .
			"\tprov:wasRevisionOf lokipage:{$strona}_{$staraRev} ;\n" .
			"\tprov:wasGeneratedBy lokievent:edited_{$strona}_{$nowaRev} .\n" .
			"lokievent:edited_{$strona}_{$nowaRev} prov:wasAssociatedWith {$autor} ;\n" .
			"\tlokirel:comment \"{$komentarz}\" ;\n" .
			"\tprov:used " . implode(" ,\n\t\t", $linki) . " .\n\n";
	}
	
	public function turtlifyDeletion($strona, $nowaRev, $staraRev, $login, $komentarz)
	{
		$autor = ($login != "") ? "lokiuser:$login" : "lokiguest";

		return "lokievent:deleted_{$strona}_{$nowaRev} prov:used lokipage:{$strona}_{$staraRev} ;\n" .
			"\tprov:wasAssociatedWith {$autor} ;\n" .
			"\tlokirel:comment \"{$komentarz}\" .\n\n";
	}
	
	public function listPages($dir = "")
	{
		$path = "data/pages/$dir";
		$res = "";
		
		foreach(scandir($path) as $file)
		{
			if($file == "." || $file == "..")
				continue;
			
			else if(preg_match("/^.*\.txt$/", $file))
			{
				if($dir != "") $res .= substr("$dir/$file", 1, -4) . "\n";
				else $res .= substr($file, 0, -4) . "\n";
			}
			
			else if(is_dir("$path/$file"))
				$res .= $this->listPages("$dir/$file") . "\n";
		}
		
		$res = str_replace("/", ":", $res);
		$res = str_replace("\\", ":", $res);
		$res = str_replace("\\", ":", $res);
		return substr($res, 0, -1);
	}

	public function register(Doku_Event_Handler $controller)
	{
		$controller->register_hook('HTML_EDITFORM_OUTPUT', 'BEFORE', $this, 'handle_html_editform_output');
		$controller->register_hook('IO_WIKIPAGE_WRITE', 'BEFORE', $this, 'handle_io_wikipage_write');
	}

	public function handle_html_editform_output(Doku_Event &$event, $param)
	{
		// Pobierz pozycję przycisku zatwierdzania
		$pos = $event->data->findElementByAttribute('type', 'submit');
		
		// Zakończ, jeżeli podgląd źródła
		if(!$pos)
			return;
		
		$html = '<script>';
		$html .= '
			function pageAdded()
			{
				var usedsites = document.getElementById("usedsites");
				var list = document.getElementById("pagelist");
				var page = list.options[list.selectedIndex].value;
				
				if(usedsites.value != "" && !usedsites.value.endsWith("\n"))
					usedsites.value += ("\nlokipage:" + page + "\n");
				
				else
					usedsites.value += ("lokipage:" + page + "\n");
			}
			function filterChanged()
			{
				var pages = document.getElementById("avpages").value.split("\n");
				var list = document.getElementById("pagelist");
				var filter = document.getElementById("pagefilter").value;
				
				list.innerHTML = "";  // Usuń wszystkie opcje
				
				for(var i = 0; i < pages.length; i++)
				{
					if(pages[i].contains(filter))
						list.innerHTML += "<option value=\'" + pages[i] + "\'>" + pages[i] + "</option>";
				}
			}
		';
		$html .= '</script>';
		
		$html .= '<br/><div>';
		$html .= '<h4>Żółwifikacja</h4>';
		
		// Uzupełnij o pola, które określają akcje, użyte linki i inne rzeczy, które zapiszesz w żółwiu
		
		$html .= '<div style="display: inline-block; vertical-align: top;"><label style="cursor: text;">Linki do wykorzystanych zasobów (jeden w kadżdym wierszu):</label><br/>';
		$html .= '<textarea name="usedSites" id="usedsites" cols="50" rows="6"></textarea></div>';
		
		$html .= '<div style="display: inline-block; vertical-align: top; margin-left: 10px;"><label style="cursor: text;">Dostępne stony (dwukrotne kliknięcie wstawia jako użyta):</label></br>';
		$html .= '<select id="pagelist" size="5" style="width: 350px;" ondblclick="pageAdded();"></select></br>';
		$html .= '<label style="cursor: text;">Filtr: </label>';
		$html .= '<input type="text" id="pagefilter" onkeyup="filterChanged();" size="35"/>';
		$html .= '<input type="hidden"id="avpages" value="' . $this->listPages() . '"/>';
		$html .= '<script>filterChanged();</script>';
		$html .= '</div>';
		$html .= '</div><br/>';
		
		// Dopisz
		$event->data->insertElement($pos, $html);
	}

	public function handle_io_wikipage_write(Doku_Event &$event, $param)  // Może polecieć dwa razy - raz dla przenoszenia starej wersji do attic, drugi dla tworzenia nowej
	{
		$this->page = ($event->data[1] !== false ? ($event->data[1] . ":") : "") . $event->data[2];
		$this->previousRev = filemtime($event->data[0][0]) !== false ? filemtime($event->data[0][0]) : $this->previousRev;
		$this->currentRev = $event->data[3] !== false ? $event->data[3] : $this->currentRev;
		$this->username = pageinfo()['userinfo']['name'];
		$this->links = array_unique(array_filter(explode("\n", str_replace("\r", "", $_POST['usedSites']))));
		$this->comment = $_POST['summary'];
		
		// Jeżeli operacja jest create lub edit to wraca, ponieważ one wykonują się w pierwszym przebiegu. Delete w drugim
		if($this->operation != false && $this->operation != 'delete')
			return;
		
		if($this->operation == false && $this->previousRev == false && $this->currentRev != false)
			$this->operation = 'create';
		
		else if($this->operation == false && $event->data[0][1] === '' && $event->data[0][2] === false)
			$this->operation = 'delete';
		
		else if($this->operation == false && $this->currentRev != false && $this->previousRev != false)
			$this->operation = 'edit';
		
		if($this->operation == false)
			return;
		
		// Wyznaczenie katalogu i utworzenie go, jeżeli trzeba
		$dir = 'data/turtles/' . ($event->data[1] !== false ? (str_replace(":", "/", $event->data[1]) . "/") : "");
		$filename = $event->data[2] . '.ttl';
		$rev = $event->data[3];
		
		if(!file_exists($dir)) mkdir($dir);
		
		// Zapis zdarzenia do pliku
		$turtlefile = fopen("$dir$filename", "a");
		
		if($this->operation == 'create')
			fwrite($turtlefile, $this->turtlifyCreation($this->page, $this->currentRev, $this->username, $this->comment, $this->links));
		
		if($this->operation == 'edit')
			fwrite($turtlefile, $this->turtlifyEdition($this->page, $this->currentRev, $this->previousRev, $this->username, $this->comment, $this->links));
		
		if($this->operation == 'delete' && $this->currentRev != false && $this->previousRev != false)  // Dopiero w drugim przebiegu będzie spełnione
			fwrite($turtlefile, $this->turtlifyDeletion($this->page, $this->currentRev, $this->previousRev, $this->username, $this->comment));
		
		fclose($turtlefile);
	}
}
